package fi.em.formPlugin;


import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.entity.LocaleString;
import kd.bos.dataentity.metadata.dynamicobject.DynamicObjectType;
import kd.bos.dataentity.metadata.dynamicobject.DynamicProperty;
import kd.bos.form.ClientProperties;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.plugin.AbstractFormPlugin;

import java.util.Calendar;
import java.util.EventObject;
import java.util.Map;

/**
 * @author cjz
 * @date 2024/11/25 11:29
 * @description:薪酬发放，递延分录
 */
public class SalaryDeferPlugin extends AbstractFormPlugin {
    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
        //递延分录
        EntryGrid entryGrid = this.getControl("nckd_defer");
        Map<String, Integer> dataIndex = entryGrid.getDataIndex();

        //当前年份
        Calendar calendar = Calendar.getInstance();
        int year = calendar.get(Calendar.YEAR);


        //递延当前年份
        entryGrid.setColumnProperty("nckd_currentyear", ClientProperties.Header,new LocaleString(String.valueOf(year)));
        entryGrid.setColumnProperty("nckd_year1", ClientProperties.Header,new LocaleString(String.valueOf(year+1)));
        entryGrid.setColumnProperty("nckd_year2", ClientProperties.Header,new LocaleString(String.valueOf(year+2)));
        entryGrid.setColumnProperty("nckd_year3", ClientProperties.Header,new LocaleString(String.valueOf(year+3)));
        entryGrid.setColumnProperty("nckd_year4", ClientProperties.Header,new LocaleString(String.valueOf(year+4)));
        entryGrid.setColumnProperty("nckd_year5", ClientProperties.Header,new LocaleString(String.valueOf(year+5)));
        entryGrid.setColumnProperty("nckd_f_year1", ClientProperties.Header,new LocaleString(String.valueOf(year-3)));
        entryGrid.setColumnProperty("nckd_f_year2", ClientProperties.Header,new LocaleString(String.valueOf(year-2)));
        entryGrid.setColumnProperty("nckd_f_year3", ClientProperties.Header,new LocaleString(String.valueOf(year-1)));
        entryGrid.setColumnProperty("nckd_f_currentyear", ClientProperties.Header,new LocaleString(String.valueOf(year)));
        entryGrid.setColumnProperty("nckd_f_year4", ClientProperties.Header,new LocaleString(String.valueOf(year+1)));
        entryGrid.setColumnProperty("nckd_f_year5", ClientProperties.Header,new LocaleString(String.valueOf(year+2)));

        DynamicObjectCollection coll = this.getModel().getDataEntity(true).getDynamicObjectCollection("nckd_defer");
        DynamicObjectType item = coll.getDynamicObjectType();
        DynamicProperty property = item.getProperty("nckd_currentyear");
        property.getDisplayName().setLocaleValue(String.valueOf(year));
        property=item.getProperty("nckd_year1");
        property.getDisplayName().setLocaleValue(String.valueOf(year+1));
        property=item.getProperty("nckd_year2");
        property.getDisplayName().setLocaleValue(String.valueOf(year+2));
        property=item.getProperty("nckd_year3");
        property.getDisplayName().setLocaleValue(String.valueOf(year+3));
        property=item.getProperty("nckd_year4");
        property.getDisplayName().setLocaleValue(String.valueOf(year+4));
        property=item.getProperty("nckd_year5");
        property.getDisplayName().setLocaleValue(String.valueOf(year+5));
        property=item.getProperty("nckd_f_year1");
        property.getDisplayName().setLocaleValue(String.valueOf(year-3));
        property=item.getProperty("nckd_f_year2");
        property.getDisplayName().setLocaleValue(String.valueOf(year-2));
        property=item.getProperty("nckd_f_year3");
        property.getDisplayName().setLocaleValue(String.valueOf(year-1));
        property=item.getProperty("nckd_f_currentyear");
        property.getDisplayName().setLocaleValue(String.valueOf(year));
        property=item.getProperty("nckd_f_year4");
        property.getDisplayName().setLocaleValue(String.valueOf(year+1));
        property=item.getProperty("nckd_f_year5");
        property.getDisplayName().setLocaleValue(String.valueOf(year+2));




    }
}
