package fi.em.opplugin;

import com.alibaba.fastjson.JSONObject;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.EntityMetadataCache;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.args.EndOperationTransactionArgs;
import kd.bos.entity.validate.ErrorLevel;
import kd.bos.entity.validate.ValidationErrorInfo;
import kd.bos.exception.KDBizException;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.AttachmentServiceHelper;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

public class ExpenseAccountFileOpPlugin extends AbstractOperationServicePlugIn {

    @Override
    public void endOperationTransaction(EndOperationTransactionArgs e) {
        super.endOperationTransaction(e);
        //获取当前操作单据数组
        String operationKey = e.getOperationKey();
        if(!"er_dailyreimbursebill".equals(operationKey)){
            DynamicObject[] dynamicObjects = e.getDataEntities();
            for (int i = 0; i < dynamicObjects.length; i++) {
                JSONObject object = new JSONObject();
                //当前单头数据包
                DynamicObject info = BusinessDataServiceHelper.loadSingle(dynamicObjects[i].getPkValue(), dynamicObjects[i].getDynamicObjectType().getName());
                BigDecimal reimburseamount = info.getBigDecimal("reimburseamount");
                if(reimburseamount.compareTo(new BigDecimal(50000)) > -1){
                    this.operationResult.addErrorInfo(new ValidationErrorInfo("",info.getPkValue(),
                            0,0,"err","billtitle",info.getString("billno")+"请关联出差申请单或上传线下审批单！", ErrorLevel.Error));
                }
                BigDecimal nckdFukuanamountfield = info.getBigDecimal("nckd_fukuanamountfield");
                DynamicObject dynamicObject = info.getDynamicObjectCollection("accountentry").get(0);
                if(dynamicObject!=null){
                    BigDecimal orireceiveamount = dynamicObject.getBigDecimal("orireceiveamount");
                    if(orireceiveamount.compareTo(nckdFukuanamountfield) == 1){
                        throw new KDBizException("收款明细分录第一行收款金额大于单头付款金额,请检查！");
                    } else if (orireceiveamount.compareTo(nckdFukuanamountfield) == -1) {
                        throw new KDBizException("收款明细分录第一行收款金额不等于单头付款金额,请检查！");
                    }
                }
            }
        }
    }
}
