package kd.bos.login.utils;

import fi.cas.opplugin.TypeUtils;
import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.logging.Log;
import kd.bos.logging.LogFactory;
import kd.bos.login.utils.sms.SMSSender;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.OperationServiceHelper;
import org.json.JSONObject;
import org.json.XML;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import java.io.*;
import java.net.Socket;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Random;

/**
 * 通用插件
 * 2024-09-02 wangj
 * 主要功能：短信发送扩展调用第三方接口
 */
public class DemoSMSSender implements SMSSender {
    protected static final Log log = LogFactory.getLog(DemoSMSSender.class);
    Long orgId = null;
    Long userId = null;
    @Override
    public boolean sendMessage(String phone, String message, String signature) {
        Boolean flag = false;
        //1.获取接口链接等信息
        DynamicObject jkpzxx = BusinessDataServiceHelper.loadSingle("nckd_jkpzxx",new QFilter[]{new QFilter("number","=","dxyz")});
        String servername =  jkpzxx.getString("nckd_servername");
        String port =  jkpzxx.getString("nckd_port");
        //2.获取xml对象
        String bodyxml = createSingleMessageRequest(phone,message,jkpzxx);
        log.info("[密码重置短信发送]申请报文："+bodyxml);
        //3.调用接口
        JSONObject cbsReturnJson =socketService(servername,port,bodyxml);
        log.info("[密码重置短信发送]返回报文："+cbsReturnJson);
        if(cbsReturnJson!=null) {
            JSONObject reMessage = cbsReturnJson.getJSONObject("Message");
            JSONObject reBodyInfo = reMessage.getJSONObject("BodyInfo");
            if (reBodyInfo.getString("Fs_retMsg").contains("success")) {//相应成功
                if ("000".equals(reBodyInfo.getString("Fs_retCode"))) {
                    flag = true;
                    log.info("[密码重置短信发送]前置机响应成功，前置机接口发送成功");
                    //写入日志
                    writeLog(phone);
                } else {
                    log.info("[密码重置短信发送]前置机响应成功，前置机接口发送失败");
                }
            } else {
                log.info("[密码重置短信发送]发送前置机响应失败："+reBodyInfo.getString("Fs_retMsg"));
            }
        }
        return flag;
    }

    private void writeLog(String phone) {
        DynamicObject[] datalist = new DynamicObject[1];
        DynamicObject writeObj = BusinessDataServiceHelper.newDynamicObject("nckd_assistantdata_mlog");
        writeObj.set("nckd_mobile",phone);
        writeObj.set("nckd_person",userId);
        writeObj.set("nckd_org",orgId);
        datalist[0]=writeObj;
        OperationServiceHelper.executeOperate("save", "nckd_assistantdata_mlog", datalist, OperateOption.create());
    }

    @Override
    public boolean sendMessage(String phone, String message) {
        Boolean flag = false;
//        //1.获取接口链接等信息
//        DynamicObject jkpzxx = BusinessDataServiceHelper.loadSingle("nckd_jkpzxx",new QFilter[]{new QFilter("number","=","dxyz")});
//        String servername =  jkpzxx.getString("nckd_servername");
//        String port =  jkpzxx.getString("nckd_port");
//        //2.获取xml对象
//        String bodyxml = createSingleMessageRequest(phone,message);
//        //3.调用接口
//        JSONObject cbsReturnJson =socketService(servername,port,bodyxml);
//        if(cbsReturnJson!=null) {
//            JSONObject reMessage = cbsReturnJson.getJSONObject("Message");
//            JSONObject reBodyInfo = reMessage.getJSONObject("BodyInfo");
//            if ("success".equals(reBodyInfo.getString("Fs_retMsg"))) {//相应成功
//                if ("000".equals(reBodyInfo.getString("Fs_retCode"))) {
//                    flag = true;
//                    log.info("短信前置机响应成功，前置机接口发送成功");
//                } else {
//                    log.info("短信前置机响应成功，前置机接口发送失败");
//                }
//            } else {
//                log.info("短信发送前置机响应失败");
//            }
//        }

        return flag;
    }

    private String createSingleMessageRequest(String phone, String message, DynamicObject jkpzxx) {
        try {
            DocumentBuilderFactory dbFactory = DocumentBuilderFactory.newInstance();
            DocumentBuilder dBuilder = dbFactory.newDocumentBuilder();
            Document doc = dBuilder.newDocument();
            //创建Message节点
            Element rootElement = doc.createElement("Message");
            doc.appendChild(rootElement);
            //创建BodyInfo节点
            Element body = doc.createElement("BodyInfo");
            rootElement.appendChild(body);
            //拼接报文
            createElement(doc, body, "Fs_channelcode", "JSX"); //渠道号
            createElement(doc, body, "Fs_transcode", "SingleMsg");  //交易码
            Date now = new Date();
            SimpleDateFormat formatter = new SimpleDateFormat("yyyyMMdd HHmmss");
            String nowStr1 = formatter.format(now);
            nowStr1 = nowStr1.replaceAll(" ","");
            Random random = new Random();
            int randomNumber = 100 + random.nextInt(900);
            createElement(doc, body, "Fs_rpid", "jsx"+nowStr1+String.valueOf(randomNumber));        //流水号（待提供）
            createElement(doc, body, "Fs_phone", phone);        //手机号
            createElement(doc, body, "Fs_ParamCount", "2");//模板数量
            createElement(doc, body, "ParamName1", "SmsVerifyCode");//模板名称1
            String ParamValue1 = message.substring(4,10);
            createElement(doc, body, "ParamValue1", ParamValue1);//模板值1
            createElement(doc, body, "ParamName2", "SceneName");//模板名称2
            createElement(doc, body, "ParamValue2", "重置密码");//模板值2
            String regOrg = getRegOrg(phone);
            createElement(doc, body, "Fs_regOrg", regOrg);//发送机构（待提供），例100802
            createElement(doc, body, "Fs_bizId", "00007");//业务类型id
            String templateId = jkpzxx.getString("nckd_user");
            createElement(doc, body, "Fs_templateId", templateId);//模板id,2409029227

            String nowStr2 = formatter.format(now);
            String Fs_reqDate = nowStr2.substring(0,8);
            createElement(doc, body, "Fs_reqDate", Fs_reqDate);//日期
            String Fs_regTime = nowStr2.substring(9,15);
            createElement(doc, body, "Fs_reqTime", Fs_regTime);//时间

            TransformerFactory transformerFactory = TransformerFactory.newInstance();
            Transformer transformer = transformerFactory.newTransformer();
            // 指定编码格式为GBK
            transformer.setOutputProperty(OutputKeys.ENCODING, "GBK");
            transformer.setOutputProperty(OutputKeys.INDENT, "yes");

            DOMSource source = new DOMSource(doc);
            StringWriter writer = new StringWriter();
            StreamResult result = new StreamResult(writer);
            transformer.transform(source, result);
            return writer.toString();
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    private String getRegOrg(String phone) {
        String orgNumber = "";
        QFilter qFilter_phone = new QFilter("phone", QCP.equals,phone);
        DynamicObject[] userCol = BusinessDataServiceHelper.load("bos_user",
                "id,entryentity.dpt,entryentity.ispartjob",new QFilter[]{qFilter_phone});
        if(userCol!=null && userCol.length>0){//手机号匹配到人员
            DynamicObject userObj = userCol[0];
            userId = userObj.getLong("id");
            DynamicObjectCollection entryList = userObj.getDynamicObjectCollection("entryentity");
            for(DynamicObject entryObj : entryList){
                boolean ispartjob = entryObj.getBoolean("ispartjob");
                if(ispartjob==false){//找到人员主组织
                    DynamicObject dpt = entryObj.getDynamicObject("dpt");
                    Long dptId = dpt.getLong("id");
                    orgId = dptId;
                    QFilter qFilter_org = new QFilter("nckd_orgfield",QCP.equals,dptId);
                    QFilter qFilter_enable = new QFilter("enable", QCP.equals,"1");
                    QFilter qFilter_status = new QFilter("status", QCP.equals, "C");
                    DynamicObject[] orgCol = BusinessDataServiceHelper.load("nckd_base_org_oa","",
                            new QFilter[]{qFilter_org,qFilter_enable,qFilter_status});
                    if(orgCol!=null && orgCol.length>0){//匹配到映射表记录
                        DynamicObject orgObj = orgCol[0];
                        orgNumber = orgObj.getString("nckd_oa_org");
                    }
                    break;
                }
            }
        }
        return orgNumber;
    }

    public static JSONObject socketService(String serverName,String port,String xmlData){
        try {
            Socket client = new Socket(serverName, TypeUtils.nullToInt(port));
            OutputStream outToServer = client.getOutputStream();
            PrintWriter out = new PrintWriter(new OutputStreamWriter(outToServer, "GBK"), true);
            out.println(xmlData);

            InputStream inFromServer = client.getInputStream();
            BufferedReader in = new BufferedReader(new InputStreamReader(inFromServer, "GBK"));
            StringBuilder responseBuilder = new StringBuilder();
            String line;
            while ((line = in.readLine()) != null) {
                responseBuilder.append(line);
            }
            String responseJson = responseBuilder.toString();
            if(responseJson.indexOf("<?xml")>0){
                int index = responseJson.indexOf("<?xml");
                responseJson = responseJson.substring(index);
            }
            JSONObject jsonObject = XML.toJSONObject(responseJson);
            client.close();
            return jsonObject;
        } catch (IOException e) {
            e.printStackTrace();
            log.info("短信发送失败："+e.getMessage());
        }
        return null;
    }

    private static void createElement(Document doc, Element parent, String name, String value) {
        Element element = doc.createElement(name);
        element.appendChild(doc.createTextNode(value));
        parent.appendChild(element);
    }
}
