package nckd.yjk.yj.plugin.docLibrary.api;

import com.alibaba.fastjson.JSONObject;
import kd.bos.cache.CacheFactory;
import kd.bos.cache.TempFileCache;
import kd.bos.coderule.api.CodeRuleInfo;
import kd.bos.context.RequestContext;
import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.operate.result.IOperateInfo;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.fileservice.FileItem;
import kd.bos.fileservice.FileService;
import kd.bos.fileservice.FileServiceFactory;
import kd.bos.openapi.common.custom.annotation.ApiController;
import kd.bos.openapi.common.custom.annotation.ApiMapping;
import kd.bos.openapi.common.custom.annotation.ApiParam;
import kd.bos.openapi.common.custom.annotation.ApiPostMapping;
import kd.bos.openapi.common.result.CustomApiResult;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.coderule.CodeRuleServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import kd.bos.servicehelper.user.UserServiceHelper;
import kd.bos.url.UrlService;
import kd.bos.util.FileNameUtils;
import nckd.yjk.yj.plugin.docLibrary.utils.FileUploadService;
import org.apache.commons.lang3.StringUtils;

import java.io.*;
import java.util.*;

import static kd.bos.entity.earlywarn.kit.StringUtil.newString;

@ApiController(value = "open",desc = "oa要件推送接口")
@ApiMapping(value = "/example")
public class OASinglepushApi implements Serializable{
    private final static String  URL_COSMICHOST=UrlService.getDomainContextUrl();

//    private final static String  URL_COSMICHOST="http://111.75.220.136:8022/ierp";

//    private static final String REMOTEHOST = "http://127.0.0.1:8080/ierp";
//
//    // 苍穹系统中,对应单据的标识,需修改
//    private static final String FORMID = "nckd_jiekoutest";
//
//    // 苍穹系统中,对应单据所属应用的标识,需修改
//    private static final String APPID = "nckd_requirements";

    
    private String postFileToCosmic(File file, String accessToken) throws Exception {

        //上传附件，返回缓存中的临时储存路径
        StringBuffer url = new StringBuffer();
//        String domainContextUrl = UrlService.getDomainContextUrl();
        url.append(URL_COSMICHOST).append("/attachment/uploadFile.do");

        //上传可能需要传的参数
        Map<String, Object> param = new HashMap<String, Object>();
//        // 上传附件,返回该附件在苍穹缓存中的临时存储路径
        try {
            return FileUploadService.getService().postFile(url.toString(), param, file, accessToken);
        } catch (Exception ex) {
            throw new RuntimeException(ex);
        }
    }



    @ApiPostMapping(value = "/singleyaojian",desc = "oa要件推送方法")
    public CustomApiResult<Map<String, Object>>  doCustomService(@ApiParam(value = "parameters") String parameters) throws Exception {




        String accessToken = RequestContext.get().getGlobalSessionId();
//        String paramsString = JSON.toJSONString(parameters);
//        JSONObject paramsJo = JSONObject.parseObject(paramsString);
        JSONObject object = JSONObject.parseObject(parameters);


        //参数校验

        if(StringUtils.isBlank(object.getString("base64")))
        {
            return CustomApiResult.fail("523","缺少参数base64");
        }
         if(StringUtils.isBlank(object.getString("orgremote")))
        {
            return CustomApiResult.fail("523","缺少参数orgremote");
        }


        QFilter qFilter98=new QFilter("nckd_otherorg", QCP.equals,object.getString("orgremote"));
        DynamicObject dynamicObject98 = BusinessDataServiceHelper.loadSingle("nckd_mapping", new QFilter[]{qFilter98});
        if(null==dynamicObject98){
            return CustomApiResult.fail("524","组织编码在映射表中不存在");
        }

        if(StringUtils.isBlank(object.getString("name")))
        {
            return CustomApiResult.fail("523","缺少参数name");
        }
        if(StringUtils.isBlank(object.getString("nckd_atttype")))
        {
            return CustomApiResult.fail("523","缺少参数nckd_atttype");
        }







        String base64 = object.getString("base64");


        File file = base64ToFile("/OA推送的要件",base64 , object.getString("name")+"."+object.getString("nckd_atttype"));

        Long nckd_attsize = file.length();

        Map<String, List<File>> allFiles = new HashMap<>();
        List<File> fileList=new ArrayList<>();
        fileList.add(file);
        allFiles.put("filename",fileList);
        //........................................................................................................................................................................................................................
        //这个result  用来装成功失败信息的
        Map<String, Object> resultInfo = new HashMap<String, Object>();
        //
        Map<String, Object> allBizBillData  = this.generateBizData(allFiles, accessToken,object,nckd_attsize);
        Map<String, Object> params=(Map<String, Object>)allBizBillData.get("params");
        Map<String, Object> billData=(Map<String, Object>)allBizBillData.get("billData");
        Map<String, Object> allAttachmentsData=(Map<String, Object>)allBizBillData.get("allAttachmentsData");




        DynamicObject dynamicObject = BusinessDataServiceHelper.newDynamicObject("nckd_requisitionlist");
//        dynamicObject.set("billno",billData.get("billno"));

        CodeRuleInfo codeRule = CodeRuleServiceHelper.getCodeRule(dynamicObject.getDataEntityType().getName(), dynamicObject, null);
        String number = CodeRuleServiceHelper.getNumber(codeRule, dynamicObject);
        dynamicObject.set("number",number);

        dynamicObject.set("status", "C");
        dynamicObject.set("enable", 1);
        dynamicObject.set("createorg",billData.get("createorg"));
        dynamicObject.set("useorg",billData.get("useorg"));
        dynamicObject.set("name",billData.get("name"));
        dynamicObject.set("nckd_atttype",billData.get("nckd_atttype"));
        dynamicObject.set("nckd_attsize",billData.get("nckd_attsize"));
//        dynamicObject.set("nckd_isrepeatcite",true);
//        dynamicObject.set("nckd_iscitebynotupload",true);
//        dynamicObject.set("nckd_iscross",false);
        dynamicObject.set("nckd_isdownloadable",true);
        dynamicObject.set("nckd_isshared",false);
        dynamicObject.set("nckd_applydate",new Date());
        dynamicObject.set("nckd_yjclass",billData.get("nckd_yjclass"));
        //获取当前登录人
        long currentUserId = UserServiceHelper.getCurrentUserId();
        //获取主组织
        long userMainOrgId = UserServiceHelper.getUserMainOrgId(currentUserId);
        List<Long> allDepartmentByUserId = UserServiceHelper.getAllDepartmentByUserId(currentUserId);
        //获取当前登录切换的组织
        long orgId = RequestContext.get().getOrgId();
        dynamicObject.set("creator",currentUserId);
        dynamicObject.set("nckd_userfield",currentUserId);
        dynamicObject.set("nckd_orgbase",billData.get("createorg"));





        List<HashMap<String, Object>> attmentInfors = (List<HashMap<String, Object>>) allAttachmentsData
                .get("filename");
        DynamicObjectCollection attCol = dynamicObject.getDynamicObjectCollection("nckd_attachmentfield");

        for (HashMap<String, Object> attmentInfor : attmentInfors) {
            String name = (String) attmentInfor.get("name");
            String url = (String) attmentInfor.get("url");
            String[] split = url.split("id=");
            if(split.length>1){
                // 参考标准源码 AttachmentFieldServiceHelper.saveTempToFileService(tempUrl, AttPk,fileName)
                TempFileCache cache = CacheFactory.getCommonCacheFactory().getTempFileCache();
                RequestContext requestContext = RequestContext.get();

                String uuid = UUID.randomUUID().toString();
                // 指定上传到文件服务器的目标地址
                String pathParam = FileNameUtils.getAttachmentFileName(requestContext.getTenantId(),
                        requestContext.getAccountId(), uuid, name);
                FileItem item = new FileItem(name, pathParam, cache.getInputStream(url));

                // 上传附件
                FileService fileService = FileServiceFactory.getAttachmentFileService();
                String path = fileService.upload(item);
                String attachmentFullUrl = UrlService.getAttachmentFullUrl(path);
                // String
                // url="http://172.20.63.42:8080/ierp/attachment/download.do?path=/ierp/1218732684788893696/202203/attachmentupload/one_1646273203365.txt";
                String downurl = UrlService.getDomainContextUrl() + "/attachment/download.do?path=" + path;
                attmentInfor.put("url", path);
                DynamicObject att = createAttDynamic(attmentInfor);
                DynamicObject addNew = attCol.addNew();
                addNew.set("fbasedataid", att);
                cache.remove(url);

            }
        }


        OperationResult result = SaveServiceHelper.saveOperate("nckd_requisitionlist", new DynamicObject[] { dynamicObject },
                OperateOption.create());



        if (!result.isSuccess()) {
            List<IOperateInfo> operateInfo = result.getAllErrorOrValidateInfo();
            String message="";
            for (IOperateInfo tempOperateInfo : operateInfo) {
                message=message+tempOperateInfo.getMessage();
            }

            return CustomApiResult.fail("654","单据保存失败"+message);
        }
        // 上传附件
        String appId ="nckd_jxyy";
        Object pkId = result.getSuccessPkIds().get(0);
        resultInfo.put("生成的要件单id", pkId);
        resultInfo.put("mes","生成要件单成功");

        return CustomApiResult.success(resultInfo);
    }



    //封装要上传的信息到苍穹平台
    public Map<String, Object> generateBizData(Map<String, List<File>> allFiles, String accessToken,JSONObject object,Long nckd_attsize) throws Exception {
        //上传文件到苍穹
        Map<String, Object> allBizBillData = new HashMap<String, Object>();
        // 生成单据数据
        Map<String, Object> billData = new HashMap<String, Object>();
        String orgremote = object.getString("orgremote");
        String name=object.getString("name");
        String nckd_atttype=object.getString("nckd_atttype");





//      billData.put("billno", "QWER123"+rand(100));
        billData.put("name", name);
        billData.put("nckd_atttype",nckd_atttype );
        billData.put("nckd_attsize",nckd_attsize );



        QFilter qFilter99=new QFilter("name", QCP.equals,"OA公文");
        DynamicObject dynamicObject = BusinessDataServiceHelper.loadSingle("nckd_classification", new QFilter[]{qFilter99});
        Long nckd_yjclass=(Long)dynamicObject.getPkValue();
        QFilter qFilter98=new QFilter("nckd_otherorg", QCP.equals,orgremote);
        DynamicObject dynamicObject98 = BusinessDataServiceHelper.loadSingle("nckd_mapping", new QFilter[]{qFilter98});
        Long createorg=(Long)dynamicObject98.getDynamicObject("nckd_xinghanorg").getLong("id");
        Long useorg=createorg;





        billData.put("nckd_yjclass",nckd_yjclass);
        billData.put("useorg",useorg);
        billData.put("createorg",createorg);
        allBizBillData.put("billData", billData);
        Map<String, Object> params = new HashMap<String, Object>();
        params.put("appId", "NCKD");
        params.put("entityName", "nckd_requisitionlist");
        allBizBillData.put("params",params);
        // 生成单据上所有的附件数据
        Map<String, Object> allAttachmentsData = new HashMap<String, Object>();
        // 单个附件面板中所有附件的信息
        List<Map<String, Object>> attachments = null;
        // 单个附件的信息
        Map<String, Object> attachmentInfo = null;
        StringBuffer uid = new StringBuffer();
        uid.append("rc-upload-").append(new Date().getTime()).append("-");
        int index = (int) (1 + Math.random()*10);
        for (String tempAttaKey : allFiles.keySet()) {
            List<File> files = allFiles.get(tempAttaKey);
            attachments = new ArrayList<Map<String, Object>>();
            for (File tempFile : files) {
                String tempAttaUrl = null;
                try {
                    tempAttaUrl = this.postFileToCosmic(tempFile, accessToken);
                } catch (Exception ex) {
                    throw new RuntimeException(ex);
                }
                attachmentInfo = new HashMap<String, Object>();
                attachmentInfo.put("entityNum", "nckd_requisitionlist");
                attachmentInfo.put("name", tempFile.getName());
                attachmentInfo.put("url", tempAttaUrl);
                attachmentInfo.put("size", tempFile.length());
                attachmentInfo.put("status", "success");
                attachmentInfo.put("uid", uid.toString() + index++);
                attachments.add(attachmentInfo);
            }
            allAttachmentsData.put(tempAttaKey, attachments);
        }
        allBizBillData.put("allAttachmentsData", allAttachmentsData);

        return allBizBillData;
    }




//    //调用自定义OpenApi上传单据&附件信息到苍穹单据上
//    public String bizSaveApi( String accessToken, Map<String, Object> allAttachmentsData) throws URISyntaxException {
//        // 自定义开放平台接口路径
//        StringBuffer url = new StringBuffer();
//        url.append(URL_COSMICHOST).append(UPLOADATTAPATH);
//        System.out.println(">>> " + url.toString());
//        // 封装数据
//        JSONObject body = new JSONObject();
//        body.put("billData", allAttachmentsData.get("billData"));
//        body.put("allAttachmentsData", allAttachmentsData.get("allAttachmentsData"));
//        body.put("params", allAttachmentsData.get("params"));
//        String responseStr = null;
//        try {
//            responseStr = HttpService.getService().doGetByHttpClient(url.toString(), accessToken, body);
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
//        return responseStr;
//    }








    //构建附件字段对象
    private DynamicObject createAttDynamic(Map<String, Object> attmentInfor) {
        DynamicObject attObj = BusinessDataServiceHelper.newDynamicObject("bd_attachment");
        String name = (String) attmentInfor.get("name");
        attObj.set("name", name);
        attObj.set("size", attmentInfor.get("size"));
        attObj.set("uid", attmentInfor.get("uid"));
        attObj.set("url", attmentInfor.get("url"));
        String type = name.substring(name.lastIndexOf(".") + 1);
        attObj.set("type", type);
        // tempfile=1表示持久化附件对象
        attObj.set("tempfile", 1);
        ORM orm = ORM.create();
        long id = orm.genLongId("bd_attachment");
        attObj.set("id", id);
        attObj.set("pageid", "");
        attObj.set("number", UUID.randomUUID().toString());
        attObj.set("status", "B");
        Date now = new Date();
        attObj.set("modifytime", now.getTime());
        attObj.set("creator", UserServiceHelper.getCurrentUserId());
        SaveServiceHelper.save(new DynamicObject[] { attObj });
        return attObj;
    }





    public static String fileToBase64(String path) {
        String base64 = null;
        InputStream in = null;
        try {
            File file = new File(path);
            in = new FileInputStream(file);
            byte[] bytes = new byte[(int) file.length()];
            in.read(bytes);
            base64 =newString(Base64.getEncoder().encode(bytes),"UTF-8");
//            base64 = new String(Base64.encodeBase64(bytes),"UTF-8");
            System.out.println("将文件["+path+"]转base64字符串:"+base64);
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (in != null) {
                try {
                    in.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
        return base64;
    }




    public static File base64ToFile(String outFilePath,String base64, String outFileName) {
        File file = null;
        //创建文件目录
        String filePath=outFilePath;
        File  dir=new File(filePath);
        if (!dir.exists() && !dir.isDirectory()) {
            dir.mkdirs();
        }
        BufferedOutputStream bos = null;
        FileOutputStream fos = null;
        try {
            byte[] bytes = Base64.getDecoder().decode(base64);
//            file=new File(filePath+"/"+outFileName+UUID.randomUUID().toString());
            file=new File(outFileName);
            fos = new FileOutputStream(file);
            bos = new BufferedOutputStream(fos);
            bos.write(bytes);
            return file;
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (bos != null) {
                try {
                    bos.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            if (fos != null) {
                try {
                    fos.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }

        return file;
    }














}
