package nckd.yjk.yj.plugin.docLibrary.form;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.cache.CacheFactory;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.fileservice.FileServiceFactory;
import kd.bos.form.CloseCallBack;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IClientViewProxy;
import kd.bos.form.ShowType;
import kd.bos.form.control.AttachmentPanel;
import kd.bos.form.control.events.ClickListener;
import kd.bos.form.events.AfterDoOperationEventArgs;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.sdk.plugin.Plugin;

import java.io.BufferedInputStream;
import java.io.InputStream;
import java.util.*;

/**
 * 父界面
 */
public class ApplyBillSecondPlugin extends AbstractBillPlugIn implements Plugin, ClickListener {
    @Override
    public void afterDoOperation(AfterDoOperationEventArgs args) {
        super.afterDoOperation(args);
        Integer b=1;
        if(args.getOperateKey().equals("yinyong")){

            Integer a=1;
            DynamicObject[] nckd_requisitionlists = BusinessDataServiceHelper.load("nckd_requisitionlist", "id,billno", null);
            FormShowParameter showParameter=new FormShowParameter();
            showParameter.setFormId("nckd_reference");
            showParameter.setCaption("要件列表");
            showParameter.setCloseCallBack(new CloseCallBack(this,"officecount"));
            showParameter.getOpenStyle().setShowType(ShowType.Modal);
            this.getView().showForm(showParameter);

        }




    }

    @Override
    public void closedCallBack(ClosedCallBackEvent e) {
        super.closedCallBack(e);

        String callBackpage = e.getActionId();
            if("officecount".equals(callBackpage)){
           DynamicObjectCollection dynamicObjectCollection= (DynamicObjectCollection)e.getReturnData();
           if(dynamicObjectCollection!=null){
               for (DynamicObject dynamicObject : dynamicObjectCollection) {
                   String number = dynamicObject.getString("nckd_number");

                   try {

                       DynamicObjectCollection dynamicObjects=(DynamicObjectCollection)dynamicObject.get("nckd_attachmentfield");

                       AttachmentPanel attachmentPanel =this.getControl("nckd_attachmentpanel");
                       List<Map<String,Object>> attachments=new ArrayList<>();
                       HashMap<String,Object> map;

                       if(dynamicObjects!=null&&dynamicObjects.size()>0){
                           for (DynamicObject attachmentField : dynamicObjects) {

                               map=new HashMap<>();
                               //获取附件字段中的单个附件
                               DynamicObject fbasedataid = attachmentField.getDynamicObject("fbasedataid");
                               map.put("type", fbasedataid.getString("type"));
                               //获取附件inputstream上传到缓存服务（附件面板数据需要上传到缓存服务中，返回非持久化的url）
                               InputStream inputStream = FileServiceFactory.getAttachmentFileService().getInputStream(fbasedataid.getString("url"));
                               String tempUrl =
                                       CacheFactory.getCommonCacheFactory().getTempFileCache().saveAsFullUrl(fbasedataid.getString("name"), new BufferedInputStream(inputStream), 2 * 3600);
                               //临时url
                               map.put("url", tempUrl);
                               //uid
                               map.put("uid", number);
                               //name
                               map.put("name", fbasedataid.getString("name"));
                               //size
                               map.put("size", fbasedataid.get("size"));

                               map.put("lastModified", new Date().getTime());
                               map.put("status", "success");
                               //client
                               map.put("client", "web");
//                               map.put("entityNum",number);


                               attachments.add(map);
                               attachmentPanel.upload(attachments);
                               // 刷新附件面板，才会重新加载数据
                               this.getView().updateView("nckd_attachmentpanel");

                           }
                       }


                   } catch (Exception ex) {
                       throw new RuntimeException(ex);
                   }







               }
           }



        }


    }

    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
        AttachmentPanel panel = this.getView().getControl("nckd_attachmentpanel");
        List<Map<String, Object>> attachmentData = panel.getAttachmentData();


        for (Map<String, Object> attachmentMap : attachmentData) {
            String visiablePreview = "1";//是否显示预览按钮
            String visiableDownload = "0";//是否显示下载按钮
            String visiableDelete = "1";//是否显示删除按钮
            String visiableRename = "1";//是否显示重命名按钮
            attachmentMap.put("visible",visiablePreview + visiableDownload + visiableDelete + visiableRename);
        }

        IClientViewProxy clientViewProxy = getView().getService(IClientViewProxy.class);
        clientViewProxy.setEntryProperty("nckd_attachmentpanel","data",attachmentData);



    }
}