package nckd.yjk.yj.plugin.docLibrary.form;

import com.bes.appserv.lic.e;
import com.tongtech.jms.ra.util.Str;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.cache.CacheFactory;
import kd.bos.cache.TempFileCache;
import kd.bos.context.RequestContext;
import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.fileservice.BatchDownloadRequest;
import kd.bos.fileservice.FileService;
import kd.bos.fileservice.FileServiceFactory;
import kd.bos.fileservice.extension.FileServiceExt;
import kd.bos.fileservice.extension.FileServiceExtFactory;
import kd.bos.form.control.Control;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.control.events.ClickListener;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.AttachmentServiceHelper;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import kd.bos.servicehelper.user.UserServiceHelper;
import kd.sdk.plugin.Plugin;
import nckd.yjk.yj.plugin.docLibrary.utils.DownLoadUtil;
import org.apache.commons.lang3.StringUtils;

import java.io.*;
import java.util.*;

/**
 * 单据界面插件
 */
public class BatchdownloadFormPLugin extends AbstractBillPlugIn implements Plugin, ClickListener {

    private final static String KEY_OK = "btnok";
    //页面取消按钮标识
    private final static String KEY_CANCEL = "btncancel";
    //页面取消按钮标识


    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        Map<String, Object> hashmap = this.getView().getFormShowParameter().getCustomParams();
        List<Map<String, Object>> atts = AttachmentServiceHelper.getAttachments((String) hashmap.get("formId"), hashmap.get("id"), "nckd_attachmentpanel");


        FileServiceExt fileServiceExt = FileServiceExtFactory.getAttachFileServiceExt();
        fileServiceExt.getRealPath("encryptPath");


        for (Map<String, Object> att : atts) {
            String number = (String) att.get("uid");
            QFilter qFilter = new QFilter("number", QCP.equals, number);
            Boolean nckd_isdownloadable = null;
            DynamicObject dynamicObject = BusinessDataServiceHelper.loadSingle("nckd_requisitionlist", "id,nckd_isdownloadable", new QFilter[]{qFilter});

            if (dynamicObject == null) {
                nckd_isdownloadable = true;
            }
            if (dynamicObject != null) {
                nckd_isdownloadable = dynamicObject.getBoolean("nckd_isdownloadable");
            }



            if (nckd_isdownloadable == true) {
                int rowIndex = this.getModel().createNewEntryRow("nckd_entryentity");
                Integer a = 1;
                this.getModel().setValue("nckd_name", att.get("name"), rowIndex);
                this.getModel().setValue("nckd_url", fileServiceExt.getRealPath((String)att.get("relativeUrl")), rowIndex);
                this.getModel().setValue("nckd_number", att.get("uid"), rowIndex);
                this.getModel().setValue("nckd_isdownloadable", nckd_isdownloadable, rowIndex);
                Integer b = 1;
            }

        }


//        this.getView().openUrl((String)att.get("url"));


    }


    @Override
    public void click(EventObject evt) {
        super.click(evt);
        //获取当前登录人
        long currentUserId = UserServiceHelper.getCurrentUserId();
        //获取主组织
        long userMainOrgId = UserServiceHelper.getUserMainOrgId(currentUserId);
        //获取当前登录切换的组织
        long orgId = RequestContext.get().getOrgId();


        Control source = (Control) evt.getSource();
        String sourceKey = source.getKey();


        if (KEY_OK.equals(sourceKey)) {
//            int rowIndex = this.getModel().createNewEntryRow("nckd_entryentity1");
            List<String> urls = new ArrayList<>();
            EntryGrid treeEntryEntity = this.getControl("nckd_entryentity");
            int[] rows = treeEntryEntity.getSelectRows();
            List<DynamicObject> fujianobjects = new ArrayList<>();

            for (int row : rows) {
                DynamicObject selectedData = this.getModel().getEntryRowEntity("nckd_entryentity", row);
                fujianobjects.add(selectedData);
            }


            this.getPageCache().put("ifContainTempfile", "false");
            FileService fs = FileServiceFactory.getAttachmentFileService();
            // 浏览器用户代理字符串,模拟浏览器userAgent访问
            String userAgent = "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/96.0.4664.93 Safari/537.36";
            // 获取附件面板的附件放在一个文件夹下
            BatchDownloadRequest.Dir attpanelDir = this.createDirAndFileByAttPanel(fujianobjects);
            // 构造BatchDownloadRequest对象
            BatchDownloadRequest bdr = new BatchDownloadRequest("alldownload");
            bdr.setDirs(new BatchDownloadRequest.Dir[] { attpanelDir});
            /**
             *BatchDownloadRequest对象的输出流
             */
            OutputStream out = null;
            String url = "";
            try {
                // 在默认临时文件目录中创建一个空文件，使用给定前缀和后缀生成其名称。
                File file = File.createTempFile("test", ".zip");
                out = new FileOutputStream(file);
                // 批量下载接口BatchDownloadRequest请求下载的地址必须是服务器中存在的地址
                fs.batchDownload(bdr, out, userAgent);
                // 临时文件地址
                // String path = file.getPath();
                // 上传为临时文件，主要作为this.getView().download提供下载地址
                TempFileCache cache = CacheFactory.getCommonCacheFactory().getTempFileCache();
                url = cache.saveAsUrl(file.getName(), new FileInputStream(file), 2 * 60);
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            } catch (IOException e) {
                e.printStackTrace();
            }
            String ifContainTempfile = this.getPageCache().get("ifContainTempfile");
            if (ifContainTempfile.equals("true")) {
                this.getView().showMessage("有附件未保存，请先保存单据");
            } else {
                // 下载后文件的地址为浏览器的下载地址
                this.getView().download(url);
            }


//            for (int row : rows) {
//                DynamicObject selectedData = this.getModel().getEntryRowEntity("nckd_entryentity", row);
//                Boolean nckd_isdownloadable = selectedData.getBoolean("nckd_isdownloadable");
//                if (nckd_isdownloadable != null) {
//
//                    String url = (String) selectedData.get("nckd_url");
//                    this.getView().openUrl(url);
// //---------------------------------------------------------------------------------
//                    try {
//                        if (!StringUtils.isBlank(DownLoadUtil.getPathfromDownloadUrl(url))) {
//                            urls.add(url);
//                        }
//                    } catch (IOException e) {
//                        throw new RuntimeException(e);
//                    }
// //---------------------------------------------------------------------------------
//
//                    //先判断是引用按钮上传的还是手动上传的，去要件单里查id
//                    String nckd_number = (String) selectedData.get("nckd_number");
//                    QFilter qFilter1 = new QFilter("number", QCP.equals, nckd_number);
//                    DynamicObject dynamicObject1 = BusinessDataServiceHelper.loadSingle("nckd_requisitionlist", new QFilter[]{qFilter1});
//                    if (dynamicObject1 != null) {
//                        //这里添加下载记录
//                        //往下载记录表跟引用下载次数那个报表里面赋值
//                        DynamicObject newDangerRepository = BusinessDataServiceHelper.newDynamicObject("nckd_download");
//                        //获取要往下载记录里赋的值
//                        newDangerRepository.set("billstatus", "A");
//
//                        newDangerRepository.set("creator", currentUserId);
//                        newDangerRepository.set("nckd_downloadperson", currentUserId);
//
//                        // 获取当前日期
//                        Date date = new Date();
//                        // 定义日期格式
////                    SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
////                    String date1 = dateFormat.format(date);
//                        newDangerRepository.set("nckd_downloadtime", date);
//                        newDangerRepository.set("nckd_yjname", dynamicObject1.getString("name"));
//                        newDangerRepository.set("nckd_yjnumber", nckd_number);
//                        SaveServiceHelper.saveOperate("nckd_download", new DynamicObject[]{newDangerRepository}, OperateOption.create());
//
//
//                        //更新下载次数
//                        QFilter qFilter = new QFilter("number", QCP.equals, nckd_number);
////                        DynamicObject dynamicObject = BusinessDataServiceHelper.loadSingle(dynamicObject1.getPkValue(),dynamicObject1.getDynamicObjectType().getName());
//                        int nckd_dlnum = dynamicObject1.getInt("nckd_dlnum");
//                        dynamicObject1.set("nckd_dlnum", nckd_dlnum + 1);
//                        SaveServiceHelper.saveOperate("nckd_requisitionlist", new DynamicObject[]{dynamicObject1}, OperateOption.create());
//                    }
//
//
//                }
//            }

//---------------------------------------------------------------------------------

//---------------------------------------------------------------------------------

                this.getView().close();
            } else if (KEY_CANCEL.equals(sourceKey)) {
                //被点击控件为取消则设置返回值为空并关闭页面（在页面关闭回调方法中必须验证返回值不为空，否则会报空指针）
                this.getView().returnDataToParent(null);
                this.getView().close();
            } else {
                this.getView().returnDataToParent(null);
                this.getView().close();
            }
        }




    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addClickListeners(KEY_OK, KEY_CANCEL);
    }



    public BatchDownloadRequest.Dir createDirAndFileByAttPanel(List<DynamicObject> list) {
        // 以附件面板标识命名文件夹
        BatchDownloadRequest.Dir attpanelDir = new BatchDownloadRequest.Dir("文件夹");

        ArrayList<BatchDownloadRequest.File> attpanelFile = new ArrayList<>();



        for (DynamicObject dynamicObject : list) {

            String path = dynamicObject.getString("nckd_url");
            String name = dynamicObject.getString("nckd_name");
            BatchDownloadRequest.File aFile = new BatchDownloadRequest.File(name, path);
            attpanelFile.add(aFile);


//            if (atturl.indexOf("path=") != -1) {
//                String[] urlsplit = atturl.split("path=");
//                String path = urlsplit[1];
//                String name = dynamicObject.getString("nckd_name");
//                BatchDownloadRequest.File aFile = new BatchDownloadRequest.File(name, path);
//                attpanelFile.add(aFile);
//            } else if (atturl.contains("/tempfile/download.do?configKey")) {
//                this.getPageCache().put("ifContainTempfile", "true");
//                break;
//            }
        }

        BatchDownloadRequest.File[] files = attpanelFile.toArray(new BatchDownloadRequest.File[attpanelFile.size()]);
        attpanelDir.setFiles(files);


        return attpanelDir;
    }
}