package nckd.yjk.yj.plugin.docLibrary.form;

import com.alibaba.druid.util.StringUtils;
import kd.bos.bill.BillShowParameter;
import kd.bos.context.RequestContext;
import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.entity.LocaleString;
import kd.bos.entity.EntityMetadataCache;
import kd.bos.entity.datamodel.ListSelectedRow;
import kd.bos.entity.datamodel.ListSelectedRowCollection;
import kd.bos.entity.operate.Donothing;
import kd.bos.entity.tree.TreeNode;
import kd.bos.form.ShowType;
import kd.bos.form.control.TreeView;
import kd.bos.form.control.events.RefreshNodeEvent;
import kd.bos.form.control.events.TreeNodeClickListener;
import kd.bos.form.control.events.TreeNodeEvent;
import kd.bos.form.events.AfterDoOperationEventArgs;
import kd.bos.form.events.SetFilterEvent;
import kd.bos.list.BillList;
import kd.bos.list.plugin.StandardTreeListPlugin;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.AttachmentServiceHelper;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.QueryServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import kd.bos.servicehelper.user.UserServiceHelper;
import kd.bos.url.UrlService;
import kd.sdk.plugin.Plugin;

import java.text.SimpleDateFormat;
import java.util.*;

/**
 * 左树右表插件，附件下载预览
 */
public class CreateTreelistPlugin extends StandardTreeListPlugin implements Plugin, TreeNodeClickListener {
    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        TreeView tv1 = this.getView().getControl("treeview");
        this.constructorData(tv1);
    }
    /**
     * 构造数据
     */
    private void   constructorData(TreeView tv1) {
        // final String   rootId = "0"; // 根节点id
        // TreeNode   rootNode = new TreeNode(null, rootId, "根节点", true);
        //   rootNode.setIsOpened(true); // 设置默认展开
        TreeNode rootNode = this.getTreeModel().getRoot();
        String   rootId = rootNode.getId();
        // 查出分组数据
        QFilter qFilter = new QFilter("name", QCP.not_equals, "知识库");

        DynamicObjectCollection types =   QueryServiceHelper.query("nckd_classification", "id,name", new QFilter[]{qFilter});
        // 查出渠道数据
//        DynamicObjectCollection   channels =   QueryServiceHelper.query("kdec_channel", "Id,name,group.Id", null);
        //按照分类分组
//        Map<String, List<DynamicObject>> datatypeMap = channels.stream()
//                .collect(Collectors.groupingBy(it -> it.getString("group.Id")));
        for (DynamicObject type : types) {//构建树节点
            // 构造一级子节点
            String   typeId = type.getString("id");
            TreeNode   tn1 = new TreeNode(rootId, typeId, type.getString("name"), true);
            tn1.setIsOpened(true);
            tn1.setColor("blue"); // 设置节点文字颜色
            tn1.setIcon("kdfont kdfont-cangku3");
//            List<DynamicObject> channelsByType = datatypeMap.get(type.getString("Id"));
//            for (DynamicObject channel : channelsByType) {
//                // 构造二级子节点
//                String   channelId = channel.getString("Id");
//                TreeNode   tn2 = new TreeNode(typeId, channelId, channel.getString("name"), false);
//                tn1.addChild(tn2);
//            }
            rootNode.addChild(tn1);
        }
//         tv1.addNode(rootNode);
        this.getTreeModel().setRoot(rootNode);//将树节点加到树模型
        //   this.getTreeModel().getRoot().addChild(rootNode);
    }


    @Override
    public void refreshNode(RefreshNodeEvent e) {
        super.refreshNode(e);
        // 取缓存的根节点
        TreeNode root = this.getTreeModel().getRoot();
        // 当前节点
        String currNodeId = e.getNodeId().toString();
        TreeNode currNode = root.getTreeNode(currNodeId, 10);
        // 判断当前节点下，是否已经缓存了子节点：如果有，无需重复加载
        if (currNode.getChildren() != null && !currNode.getChildren().isEmpty()) {
            // 直接返回缓存的子节点
            e.setChildNodes(currNode.getChildren());
        } else {
            // 没有缓存子节点
            if (StringUtils.equals(currNodeId, root.getId())) {
                // 当前要刷新的是根节点：读取全部 知识体系主数据, 生成节点返回
                e.setChildNodes(null);
            } else {
                // 当前要刷新非根节点
                // 如果采用了懒加载子节点方案，则需要在这里尝试加载子节点
                e.setChildNodes(null);
            }
        }


    }



    @Override
    public void   registerListener(EventObject e) {
        super.registerListener(e);
        TreeView   tv1 = this.getView().getControl("treeview");
        tv1.addTreeNodeClickListener(this);



    }

    @Override
    public void   treeNodeClick(TreeNodeEvent e) {
        super.treeNodeClick(e);
        BillList billList = this.getControl("billlistap");
        billList.refresh();
    }
    @Override
    public void   setFilter(SetFilterEvent e) {
        super.setFilter(e);
        String   nodeId = this.getTreeModel().getCurrentNodeId().toString();

        long currentUserId = UserServiceHelper.getCurrentUserId();
        long userMainOrgId = UserServiceHelper.getUserMainOrgId(currentUserId);
        long orgId = RequestContext.get().getOrgId();






//*******************************************************************************************************************
        QFilter qFiltercommonuser=new QFilter("nckd_userfield.id",QCP.equals,currentUserId);
        DynamicObject dynamicObjectcommonuser = BusinessDataServiceHelper.loadSingle("nckd_commonuser", new QFilter[]{qFiltercommonuser});
        if(dynamicObjectcommonuser!=null){
            DynamicObject nckd_orgbase = dynamicObjectcommonuser.getDynamicObject("nckd_orgbase");
            long orgbaseid=nckd_orgbase.getLong("id");
            e.getQFilters().add(new QFilter("nckd_orgbase.id",QCP.equals,orgbaseid));
        }
        else{
            QFilter qFilteruser=new QFilter("creator.id",QCP.equals,currentUserId);
            QFilter qFiltershare1=new QFilter("nckd_isshared",QCP.equals,true);
            QFilter qFiltershare2=new QFilter("nckd_orgbase.id",QCP.equals,userMainOrgId);
            QFilter qFiltershare=qFiltershare1.and(qFiltershare2);
            e.getQFilters().add(qFilteruser.or(qFiltershare));
//            e.getQFilters().add(new QFilter("creator.id",QCP.equals,currentUserId));
        }



//*******************************************************************************************************************



        if (this.getTreeModel().getRoot().getId().equals(nodeId)) {
            e.getQFilters().add(new QFilter("nckd_yjclass.name", QCP.not_equals, "知识库"));
            return;
        }
        Long nodeId1=Long.parseLong(nodeId);
        e.getQFilters().add(new QFilter("nckd_yjclass.id", QCP.equals, nodeId1));
        e.getQFilters().add(new QFilter("nckd_yjclass.name", QCP.not_equals, "知识库"));



//        e.addCustomQFilter();

    }



    @Override
    public void afterDoOperation(AfterDoOperationEventArgs args) {
        super.afterDoOperation(args);

        Integer b=1;

        if(args.getOperateKey().equals("newyj")){
            BillShowParameter billShowParameter = new BillShowParameter();
            billShowParameter.setFormId("nckd_application_form");
            billShowParameter.setCaption("要件列表");
            billShowParameter.getOpenStyle().setShowType(ShowType.Modal);
            this.getView().showForm(billShowParameter);
        }


        if(args.getOperateKey().equals("batchdownload")){

            if(true){

            }


            Donothing donothing=(Donothing)args.getSource();
            ListSelectedRowCollection selectedRows = this.getSelectedRows();
//            Long id = (Long) donothing.getListFocusRow().getPrimaryKeyValue();
            String formID = donothing.getEntityId();


            for (ListSelectedRow selectedRow : selectedRows) {

            Long id = (Long)selectedRow.getPrimaryKeyValue();

            DynamicObject obj = BusinessDataServiceHelper.loadSingle(id,formID);

            boolean nckd_isdownloadable = obj.getBoolean("nckd_isdownloadable");
                String number = obj.getString("number");
                String name = obj.getString("name");



                if(nckd_isdownloadable==true) {


//                    Object nckd_yjclass = obj.getDynamicObject("nckd_yjclass").getLong("id");
//
//                    QFilter qFilter99=new QFilter("id", QCP.equals,nckd_yjclass);
//                    DynamicObject dynamicObject98 = BusinessDataServiceHelper.loadSingle("nckd_classification", new QFilter[]{qFilter99});
//                    String name1=dynamicObject98.getLocaleString("name").getLocaleValue();
//
//
//
//


                //下载附件
                List<Object> attchIdSet = new ArrayList<>();
                DynamicObjectCollection picCo = obj.getDynamicObjectCollection("nckd_attachmentfield");


                if (picCo != null && !picCo.isEmpty()) {
                    picCo.forEach(attach -> {
                        attchIdSet.add(attach.getDynamicObject("fbasedataId").getPkValue());
                    });
                    DynamicObject[] sourceAttachments = BusinessDataServiceHelper.load(attchIdSet.toArray(), EntityMetadataCache.getDataEntityType("bd_attachment"));

                    Object url = sourceAttachments[0].get("url");
                    String attachmentFullUrl = UrlService.getAttachmentFullUrl(url.toString());
                    this.getView().openUrl(attachmentFullUrl);
//                FileServiceFactory.getAttachmentFileService().preview();

                    DynamicObject newDangerRepository = BusinessDataServiceHelper.newDynamicObject("nckd_download");
                    //获取要往下载记录里赋的值
                    newDangerRepository.set("billstatus","A");

                    long currentUserId = UserServiceHelper.getCurrentUserId();
                    newDangerRepository.set("creator",currentUserId);
                    newDangerRepository.set("nckd_downloadperson",currentUserId);

                    // 获取当前日期
                    Date date = new Date();
                    // 定义日期格式
//                    SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
//                    String date1 = dateFormat.format(date);
                    newDangerRepository.set("nckd_downloadtime",date);
                    newDangerRepository.set("nckd_yjname",name);
                    newDangerRepository.set("nckd_yjnumber",number);
                    SaveServiceHelper.saveOperate("nckd_download",new DynamicObject[]{newDangerRepository},OperateOption.create());


                    //更新下载次数
                    QFilter qFilter=new QFilter("number",QCP.equals,number);
                    DynamicObject dynamicObject = BusinessDataServiceHelper.loadSingle(obj.getPkValue(),obj.getDynamicObjectType().getName());
                    int nckd_dlnum = dynamicObject.getInt("nckd_dlnum");
                    dynamicObject.set("nckd_dlnum",nckd_dlnum+1);
                    SaveServiceHelper.saveOperate("nckd_requisitionlist",new DynamicObject[]{dynamicObject}, OperateOption.create());


                }
            }
        }

        }







        //预览==============================================
        if(args.getOperateKey().equals("preview")){
            Donothing donothing=(Donothing)args.getSource();
            Long id = (Long) donothing.getListFocusRow().getPrimaryKeyValue();
            String formID = donothing.getEntityId();
            DynamicObject obj = BusinessDataServiceHelper.loadSingle(id,formID);
            String number = obj.getString("number");
            String name = obj.getString("name");

                //下载附件
                List<Object> attchIdSet = new ArrayList<>();
                DynamicObjectCollection picCo = obj.getDynamicObjectCollection("nckd_attachmentfield");
                if (picCo != null && !picCo.isEmpty()) {
                    picCo.forEach(attach -> {
                        attchIdSet.add(attach.getDynamicObject("fbasedataId").getPkValue());
                    });
                    DynamicObject[] sourceAttachments = BusinessDataServiceHelper.load(attchIdSet.toArray(), EntityMetadataCache.getDataEntityType("bd_attachment"));

                    String url = sourceAttachments[0].getString("url");
                    String attachmentFullUrl = UrlService.getAttachmentFullUrl(url.toString());
                    String previewUrl = UrlService.getAttachmentPreviewUrl(url.toString());
//                    String domainContextUrl = UrlService.getDomainContextUrl() + "/attachment/preview.do?path=";
//                    String previewUrl=domainContextUrl + url;

//                    List<Map<String, Object>> attachments = AttachmentServiceHelper.getAttachments(formID, id, "nckd_attachmentfield", true);
//                    this.getView().previewAttachment(attachments.get(0));


                    Map<String, Object> map = new HashMap<>();
                    map.put("url",attachmentFullUrl );
                    map.put("uid", sourceAttachments[0].getString("uid"));
                    map.put("name", sourceAttachments[0].getString("name"));
                    map.put("previewurl",previewUrl);
                    map.put("size", sourceAttachments[0].getString("size"));
                    map.put("status", "success");
                    map.put("type", sourceAttachments[0].getString("type"));
                    this.getView().previewAttachment(map);




















//                    String attachmentFullUrl = UrlService.getAttachmentFullUrl(url.toString());
//                    String domainContextUrl = UrlService.getDomainContextUrl() + "/attachment/preview.do?path=";
//                    this.getView().openUrl(domainContextUrl + url);
 //                    String previewUrl=UrlService.getAttachmentPreviewUrl(url);
//                    this.getView().openUrl(previewUrl);
//                    UrlService.getAttachmentDownloadUrl("url");

                    //往预览记录表里面赋值
                    DynamicObject newDangerRepository = BusinessDataServiceHelper.newDynamicObject("nckd_preview");
                    //获取要往预览记录里赋的值
                    newDangerRepository.set("billstatus","A");

                    long currentUserId = UserServiceHelper.getCurrentUserId();
                    newDangerRepository.set("creator",currentUserId);
                    newDangerRepository.set("nckd_previewperson",currentUserId);

                    // 获取当前日期
                    Date date = new Date();
                    // 定义日期格式
//                    SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
//                    String date1 = dateFormat.format(date);
                    newDangerRepository.set("nckd_previewtime",date);
                    newDangerRepository.set("nckd_yjname",name);
                    newDangerRepository.set("nckd_yjnumber",number);
                    SaveServiceHelper.saveOperate("nckd_preview",new DynamicObject[]{newDangerRepository}, OperateOption.create());


                    //更新预览次数
                    QFilter qFilter=new QFilter("number",QCP.equals,number);
                    DynamicObject dynamicObject = BusinessDataServiceHelper.loadSingle(obj.getPkValue(),obj.getDynamicObjectType().getName());
                    int nckd_previewnum = dynamicObject.getInt("nckd_previewnum");
                    dynamicObject.set("nckd_previewnum",nckd_previewnum+1);
                    SaveServiceHelper.saveOperate("nckd_requisitionlist",new DynamicObject[]{dynamicObject}, OperateOption.create());



                }



                }


        if (args.getOperateKey().equals("download")) {
            Donothing donothing = (Donothing)args.getSource();
            Long id = (Long)donothing.getListFocusRow().getPrimaryKeyValue();
            String formID = donothing.getEntityId();
            DynamicObject obj = BusinessDataServiceHelper.loadSingle(id, formID);

            //获取一下创建人
            long userid=UserServiceHelper.getCurrentUserId();
            long creator = obj.getDynamicObject("creator").getLong("id");


//            if(userid==creator||){
//
//            }

            boolean nckd_isdownloadable = obj.getBoolean("nckd_isdownloadable");

            if (nckd_isdownloadable) {
                String number = obj.getString("number");
                String name = obj.getString("name");

                List<Object> attchIdSet = new ArrayList();
                DynamicObjectCollection picCo = obj.getDynamicObjectCollection("nckd_attachmentfield");
                if (picCo != null && !picCo.isEmpty()) {
                    picCo.forEach((attach) -> {
                        attchIdSet.add(attach.getDynamicObject("fbasedataId").getPkValue());
                    });
                    DynamicObject[] sourceAttachments = BusinessDataServiceHelper.load(attchIdSet.toArray(), EntityMetadataCache.getDataEntityType("bd_attachment"));
                    Object url = sourceAttachments[0].get("url");
                    String attachmentFullUrl = UrlService.getAttachmentFullUrl(url.toString());
                    this.getView().openUrl(attachmentFullUrl);


                    //往下载记录表跟引用下载次数那个报表里面赋值
                    DynamicObject newDangerRepository = BusinessDataServiceHelper.newDynamicObject("nckd_download");
                    //获取要往下载记录里赋的值
                    newDangerRepository.set("billstatus","A");

                    long currentUserId = UserServiceHelper.getCurrentUserId();
                    newDangerRepository.set("creator",currentUserId);
                    newDangerRepository.set("nckd_downloadperson",currentUserId);

                    // 获取当前日期
                    Date date = new Date();
                    // 定义日期格式
//                    SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
//                    String date1 = dateFormat.format(date);
                    newDangerRepository.set("nckd_downloadtime",date);
                    newDangerRepository.set("nckd_yjname",name);
                    newDangerRepository.set("nckd_yjnumber",number);
                    SaveServiceHelper.saveOperate("nckd_download",new DynamicObject[]{newDangerRepository},OperateOption.create());


                    //更新下载次数
                    QFilter qFilter=new QFilter("number",QCP.equals,number);
                    DynamicObject dynamicObject = BusinessDataServiceHelper.loadSingle(obj.getPkValue(),obj.getDynamicObjectType().getName());
                    int nckd_dlnum = dynamicObject.getInt("nckd_dlnum");
                    dynamicObject.set("nckd_dlnum",nckd_dlnum+1);
                    SaveServiceHelper.saveOperate("nckd_requisitionlist",new DynamicObject[]{dynamicObject}, OperateOption.create());

                }
            }
        }



//        if(args.getOperateKey().equals("preview")){
//
//
//            Donothing donothing=(Donothing)args.getSource();
//            Long id = (Long) donothing.getListFocusRow().getPrimaryKeyValue();
//            String formID = donothing.getEntityId();
//            DynamicObject obj = BusinessDataServiceHelper.loadSingle(id,formID);
//
//            //下载附件
//            List<Object> attchIdSet = new ArrayList<>();
//            DynamicObjectCollection picCo = obj.getDynamicObjectCollection("nckd_attachmentfield");
//            if (picCo != null && !picCo.isEmpty()) {
//                picCo.forEach(attach -> {
//                    attchIdSet.add(attach.getDynamicObject("fbasedataId").getPkValue());
//                });
//                DynamicObject[] sourceAttachments = BusinessDataServiceHelper.load(attchIdSet.toArray(), EntityMetadataCache.getDataEntityType("bd_attachment"));
//
//                String url = sourceAttachments[0].getString("url");
//
////                String attachmentFullUrl = UrlService.getAttachmentFullUrl(url.toString());
//
//                String domainContextUrl = UrlService.getDomainContextUrl() + "/attachment/preview.do?path=";
//                this.getView().openUrl(domainContextUrl + url);
//
////                Map<String, Object> map=new HashMap<>();
////                map.put("previewurl",sourceAttachments[0].get("previewurl"));
//
//
////                this.getView().openUrl(attachmentFullUrl);
////                FileServiceFactory.getAttachmentFileService().preview();
//
//                //论坛提供的方法
////            List<Map<String, Object>> attachments = AttachmentServiceHelper.getAttachments(formID,id, "individuation");
////            Map<String, Object> stringObjectMap = attachments.get(0);
////            Object url = stringObjectMap.get("url");
////            String attachmentFullUrl = UrlService.getAttachmentFullUrl(url.toString());
////            this.getView().openUrl(attachmentFullUrl);
//
//
////            //附件预览参数构建
////            Map<String, Object> map = new HashMap<>();
////
////            this.getView().previewAttachment(stringObjectMap);
//
//
////            FileServiceFactory.getAttachmentFileService().preview();
//            }
//
//
//        }


        };


}



