package nckd.yjk.yj.plugin.docLibrary.form;

import com.alibaba.druid.util.StringUtils;
import kd.bos.context.RequestContext;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.form.field.BasedataEdit;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.user.UserServiceHelper;
import kd.sdk.plugin.Plugin;

import java.util.ArrayList;
import java.util.EventObject;
import java.util.List;

public class DocF7SelectPlugin extends AbstractFormPlugin implements Plugin,BeforeF7SelectListener {

    /**
     * 要件单F7列表过滤
     */

    @Override
    public void beforeF7Select(BeforeF7SelectEvent arg0) {
        //获取当前登录人
        long currentUserId = UserServiceHelper.getCurrentUserId();
        //获取主组织
        long userMainOrgId = UserServiceHelper.getUserMainOrgId(currentUserId);
        //获取当前登录切换的组织
        long orgId = RequestContext.get().getOrgId();

//        DynamicObject[] yaojiandanlist = BusinessDataServiceHelper.load("nckd_requirements","id,billno",null);
//
//
//        for (int i = 0; i < yaojiandanlist.length; i++) {
//            DynamicObject info = BusinessDataServiceHelper.loadSingle(yaojiandanlist[i].getPkValue(),yaojiandanlist[i].getDynamicObjectType().getName());
//            info.getBoolean("nckd_isrepeatcite");
//            info.getBoolean("nckd_iscitebynotupload");
//            info.getBoolean("nckd_iscross");
//            info.getBoolean("nckd_isdownloadable");
//            info.getBoolean("nckd_isreferenceable");
//        }

        //获取属性值
        String fieldKey = arg0.getProperty().getName();

        if (StringUtils.equals(fieldKey, "nckd_requirements")){
            List<QFilter> qFilters=new ArrayList<>();
            Integer a=1;
//            *********************************
            QFilter qFilter=new QFilter("enable", QCP.equals,"1");
            QFilter qFilter1=new QFilter("nckd_isreferenceable", QCP.equals,true);
            qFilters.add(qFilter1);

//             //*********************************
            QFilter qFilter21   =new QFilter("nckd_isrepeatcite", QCP.equals,true);

            QFilter qFilter22   =new QFilter("nckd_isrepeatcite", QCP.equals,false);
            List<String> arrayList = new ArrayList<>();
            DynamicObject[] load = BusinessDataServiceHelper.load("nckd_yinyongbiao", "nckd_elecoding", null);
            for (int i = 0; i < load.length; i++) {
                arrayList.add( load[i].get("nckd_elecoding").toString());
            }

            QFilter qFilter23   =new QFilter("number", QCP.not_in,arrayList);

            QFilter qFilter2=qFilter21.or(qFilter22.and(qFilter23));
            qFilters.add(qFilter21);

            //***********************
            QFilter qFilter31   =new QFilter("nckd_iscitebynotupload", QCP.equals,true);
            QFilter qFilter32   =new QFilter("nckd_iscitebynotupload", QCP.equals,false);

            QFilter qFilter33   =new QFilter("creator", QCP.equals,currentUserId);
            QFilter qFilter3=qFilter31.or(qFilter32.and(qFilter33));
            qFilters.add(qFilter3);


            //***********************
            QFilter qFilter41   =new QFilter("nckd_iscross", QCP.equals,true);
            QFilter qFilter42   =new QFilter("nckd_iscross", QCP.equals,false);

            QFilter qFilter43   =new QFilter("createorg", QCP.equals,orgId);
//            DynamicObject[] load = BusinessDataServiceHelper.load("nckd_requirements", "nckd_elecoding", null);

            QFilter qFilter4=qFilter41.or(qFilter42.and(qFilter43));
            qFilters.add(qFilter4);

            DynamicObject[] load1 = BusinessDataServiceHelper.load("nckd_requisitionlist", "name", new QFilter[]{qFilter4});
            for (int i = 0; i < load1.length; i++) {
                String name = load1[i].getString("name");
            }

            arg0.setCustomQFilters(qFilters);


        }
    }


    @Override
    public void   registerListener(EventObject e) {
        super.registerListener(e);
        BasedataEdit fieldEdit = this.getView().getControl("nckd_requirements");
        fieldEdit.addBeforeF7SelectListener(this);
    }
}
