package nckd.yjk.yj.plugin.docLibrary.form;

import com.alibaba.druid.util.StringUtils;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.context.RequestContext;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.EntityMetadataCache;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.field.BasedataEdit;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.user.UserServiceHelper;
import kd.sdk.plugin.Plugin;

import java.util.*;
/**
 * 获取附件信息
 */
public class GetfileNamePlugin extends AbstractBillPlugIn implements Plugin, BeforeF7SelectListener {
    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        Integer b=1;
        super.propertyChanged(e);
        if (e.getProperty().getName().equals("nckd_attachmentfield")) {
            List<Object> attchIdSet = new ArrayList<>();
            DynamicObjectCollection picco = (DynamicObjectCollection) this.getModel().getValue("nckd_attachmentfield");
            if (picco != null && !picco.isEmpty()) {
                picco.forEach(attach -> {
                    attchIdSet.add(attach.getDynamicObject("fbasedataId").getPkValue());
                });
                DynamicObject[] sourceAttachments = BusinessDataServiceHelper.load(attchIdSet.toArray(), EntityMetadataCache.getDataEntityType("bd_attachment"));
                for (int i = 0; i < sourceAttachments.length; i++) {
                    String name = sourceAttachments[0].getString("name");
                    String type = sourceAttachments[0].getString("type");
                    String size= sourceAttachments[0].getString("size");
                    int num = this.getModel().getEntryCurrentRowIndex("entryentity");

                    name=name.substring(0,name.indexOf("."));
                    this.getModel().setValue("nckd_attname",name,num);
                    this.getModel().setValue("nckd_atttype",type,num);
                    this.getModel().setValue("nckd_attsize",size,num);
                    Integer d=1;

                }
            }
        }
    }

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        //获取当前登录人
        long currentUserId = UserServiceHelper.getCurrentUserId();
        //获取主组织
        long userMainOrgId = UserServiceHelper.getUserMainOrgId(currentUserId);
        //获取当前登录切换的组织
        long orgId = RequestContext.get().getOrgId();
        this.getModel().setValue("nckd_orgbase",userMainOrgId);
        this.getModel().setValue("nckd_orgfield1",orgId);
        Integer a=1;
    }

    @Override
    public void beforeF7Select(BeforeF7SelectEvent beforeF7SelectEvent) {
        //获取属性值
        String fieldKey = beforeF7SelectEvent.getProperty().getName();
        if (StringUtils.equals(fieldKey, "nckd_yjclass")) {

            QFilter qFilter = new QFilter("name", QCP.not_equals, "OA公文");
            List<QFilter> qFilters = new ArrayList<>();
            qFilters.add(qFilter);
            beforeF7SelectEvent.setCustomQFilters(qFilters);
        }
    }



    @Override
    public void   registerListener(EventObject e) {
        super.registerListener(e);
        BasedataEdit fieldEdit = this.getView().getControl("nckd_yjclass");
        fieldEdit.addBeforeF7SelectListener(this);
    }
//    @Override
//    public void afterBindData(EventObject e) {
//        super.beforeBindData(e);
//        Map<String,Object> map = new HashMap();
//        map.put("maxatmcount",1);
//        this.getView().updateControlMetadata("dmp_attachmentpanelap",map);
//    }
}

