package nckd.yjk.yj.plugin.docLibrary.form;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.EntityMetadataCache;
import kd.bos.entity.operate.Donothing;
import kd.bos.form.events.AfterDoOperationEventArgs;
import kd.bos.form.events.SetFilterEvent;
import kd.bos.list.plugin.AbstractListPlugin;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.url.UrlService;
import kd.sdk.plugin.Plugin;

import java.util.ArrayList;
import java.util.List;

/**
 * 知识库列表过滤
 */
public class KnowledgePlugin extends AbstractListPlugin implements Plugin {
    @Override
    public void setFilter(SetFilterEvent e) {
        super.setFilter(e);
        String name="知识库";
        try {
            e.getQFilters().add(new QFilter("nckd_yjclass.name", QCP.equals,name));
        } catch (Exception ex) {
            throw new RuntimeException(ex);
        }
    }

    @Override
    public void afterDoOperation(AfterDoOperationEventArgs args) {
        super.afterDoOperation(args);

        Integer b=1;

        if(args.getOperateKey().equals("individuation")){
            Donothing donothing=(Donothing)args.getSource();
            Long id = (Long) donothing.getListFocusRow().getPrimaryKeyValue();
            String formID = donothing.getEntityId();
            DynamicObject obj = BusinessDataServiceHelper.loadSingle(id,formID);
            boolean nckd_isdownloadable = obj.getBoolean("nckd_isdownloadable");
            if(nckd_isdownloadable==true) {
                //下载附件
                List<Object> attchIdSet = new ArrayList<>();
                DynamicObjectCollection picCo = obj.getDynamicObjectCollection("nckd_attachmentfield");
                if (picCo != null && !picCo.isEmpty()) {
                    picCo.forEach(attach -> {
                        attchIdSet.add(attach.getDynamicObject("fbasedataId").getPkValue());
                    });
                    DynamicObject[] sourceAttachments = BusinessDataServiceHelper.load(attchIdSet.toArray(), EntityMetadataCache.getDataEntityType("bd_attachment"));

                    Object url = sourceAttachments[0].get("url");
                    String attachmentFullUrl = UrlService.getAttachmentFullUrl(url.toString());
                    this.getView().openUrl(attachmentFullUrl);
//                FileServiceFactory.getAttachmentFileService().preview();
                }
            }

            //论坛提供的方法
//            List<Map<String, Object>> attachments = AttachmentServiceHelper.getAttachments(formID,id, "individuation");
//            Map<String, Object> stringObjectMap = attachments.get(0);
//            Object url = stringObjectMap.get("url");
//            String attachmentFullUrl = UrlService.getAttachmentFullUrl(url.toString());
//            this.getView().openUrl(attachmentFullUrl);


//            //附件预览参数构建
//            Map<String, Object> map = new HashMap<>();
//
//            this.getView().previewAttachment(stringObjectMap);



//            FileServiceFactory.getAttachmentFileService().preview();
        }





        if(args.getOperateKey().equals("preview")){


            Donothing donothing=(Donothing)args.getSource();
            Long id = (Long) donothing.getListFocusRow().getPrimaryKeyValue();
            String formID = donothing.getEntityId();
            DynamicObject obj = BusinessDataServiceHelper.loadSingle(id,formID);



                //下载附件
                List<Object> attchIdSet = new ArrayList<>();
                DynamicObjectCollection picCo = obj.getDynamicObjectCollection("nckd_attachmentfield");
                if (picCo != null && !picCo.isEmpty()) {
                    picCo.forEach(attach -> {
                        attchIdSet.add(attach.getDynamicObject("fbasedataId").getPkValue());
                    });
                    DynamicObject[] sourceAttachments = BusinessDataServiceHelper.load(attchIdSet.toArray(), EntityMetadataCache.getDataEntityType("bd_attachment"));

                    String url = sourceAttachments[0].getString("url");

//                String attachmentFullUrl = UrlService.getAttachmentFullUrl(url.toString());

                    String domainContextUrl = UrlService.getDomainContextUrl() + "/attachment/preview.do?path=";
                    this.getView().openUrl(domainContextUrl + url);

//                Map<String, Object> map=new HashMap<>();
//                map.put("previewurl",sourceAttachments[0].get("previewurl"));


//                this.getView().openUrl(attachmentFullUrl);
//                FileServiceFactory.getAttachmentFileService().preview();

                    //论坛提供的方法
//            List<Map<String, Object>> attachments = AttachmentServiceHelper.getAttachments(formID,id, "individuation");
//            Map<String, Object> stringObjectMap = attachments.get(0);
//            Object url = stringObjectMap.get("url");
//            String attachmentFullUrl = UrlService.getAttachmentFullUrl(url.toString());
//            this.getView().openUrl(attachmentFullUrl);


//            //附件预览参数构建
//            Map<String, Object> map = new HashMap<>();
//
//            this.getView().previewAttachment(stringObjectMap);


//            FileServiceFactory.getAttachmentFileService().preview();
                }


        }


    };
}