package nckd.yjk.yj.plugin.docLibrary.utils;

import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.alibaba.fastjson.JSONObject;

public class BizOperateService {
	
	private static final BizOperateService service = new BizOperateService();
	
	private static final String relativePath = "/kapi/app/sys/BizCustomSave";
	
	private BizOperateService() {}
	
    //静态工厂方法   
    public static BizOperateService getService() {  
        return service;  
    } 
    
    /**
     * 远程上传单据数据 & 附件文件到苍穹系统
     * @param remotehost	苍穹系统访问地址
     * @param accessToken	
     * @param formData		单据数据
     * @param attchmentsUrl	附件在苍穹系统中的保存地址
     * @param attchmentpanles	第三方系统中附件面板的标识,如无可传null
     * @return
     * @throws URISyntaxException
     */
    public String BizSave(String remotehost, String accessToken, Map<String, Object> formData, String attchmentsUrl, List<String> attchmentpanles) 
    		throws URISyntaxException {
		List<String> attchmentsUrlList = new ArrayList<String>();
		attchmentsUrlList.add(attchmentsUrl);
		// 默认一个附件面板
    	attchmentpanles = (attchmentpanles == null) ? new ArrayList<String>() : attchmentpanles;
    	if (attchmentpanles.size() == 0) {
    		attchmentpanles.add("attachmentpanel");
    	}
    	// 自定义开放平台接口路径
    	String url = remotehost + relativePath;
    	// 附件信息
    	Map<String, Object> attachmentInfo = new HashMap<String, Object>();
    	List<Map<String, Object>> attachments = null;
    	Map<String, Object> attachment = null;
    	StringBuffer uid = new StringBuffer("rc-upload-");
    	uid.append(new Date().getTime());
		uid.append("-");
		int index = (int) (1 + Math.random()*10);
    	// 多个附件面板
    	for (String tempattchmentpanle : attchmentpanles) {
    		attachments = new ArrayList<Map<String, Object>>();
    		// 多个附件
    		for (String attchmentUrl : attchmentsUrlList) {
    			attachment = new HashMap<String, Object>();
    			attachment.put("name", formData.get("fileName"));
    			attachment.put("url", attchmentUrl);
    			uid.append(index);
    			attachment.put("uid", uid);
    			index++;
    			attachment.put("size", formData.get("fileSize"));
    			attachment.put("description", formData.get("description"));
    			attachments.add(attachment);
    		}
    		attachmentInfo.put(tempattchmentpanle, attachments);
    	}
    	// 封装数据
    	JSONObject body = new JSONObject();
    	body.put("accessToken", accessToken);
    	body.put("bizObject", formData);
    	body.put("attachmentInfo", attachmentInfo);
		String responseStr = null;
		try {
			responseStr = HttpService.getService().doGetByHttpClient(url, body);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return responseStr;
    }
    
    /**
     * 远程查询附件信息
     * @param remotehost	苍穹系统访问地址
     * @param accessToken	
     * @param params		参数
     * @return
     */
    public String bizGetAttachmentsInfo(String remotehost, String accessToken, Map<String, Object> params) {
    	// 自定义开放平台接口路径
    	String url = remotehost + relativePath;
    	// 封装参数
    	JSONObject body = new JSONObject();
    	body.put("accessToken", accessToken);
    	body.put("bizObject", params);
		String responseStr = null;
		try {
			responseStr = HttpService.getService().doGetByHttpClient(url, body);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return responseStr;
    }
}
