package nckd.yjk.yj.plugin.docLibrary.utils;

import kd.bos.cache.CacheFactory;
import kd.bos.cache.TempFileCache;
import kd.bos.fileservice.BatchDownloadRequest;
import kd.bos.fileservice.FileService;
import kd.bos.fileservice.FileServiceFactory;
import kd.bos.fileservice.path.FilePathFactory;
import org.apache.commons.lang3.StringUtils;


import java.io.*;
import java.net.URLDecoder;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import java.util.Random;

public class DownLoadUtil {
    public static String getPathfromDownloadUrl(String url) throws IOException {
        String path = kd.bos.dataentity.utils.StringUtils.substringAfter(url, "path=");
        path = URLDecoder.decode(path, "UTF-8");
        if (path.contains("kdedcba")) {
            path = kd.bos.dataentity.utils.StringUtils.substringBefore(path, "&kdedcba");
        }

        if (path.contains("?v=1")) {
            path = path.replace("?v=1", "");

        }
        path = FilePathFactory.getFilePath().getRealPath(path);
        if(StringUtils.isBlank(path)) {
            path = url;
        }
        return path;
    }

    public static String getBatchDownLoadUrl(List<String> urls) {
        FileService fileService = FileServiceFactory.getAttachmentFileService();

        String userAgent = "Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36";

        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
        String date = dateFormat.format(new Date());
        String fileName = "全部附件_" + date + ".zip";

        BatchDownloadRequest.File[] files = new BatchDownloadRequest.File[urls.size()];
        for (int i = 0; i < urls.size(); ++i) {
            String path = (String) urls.get(i);
            BatchDownloadRequest.File file = new BatchDownloadRequest.File(path.substring(path.lastIndexOf("/") + 1), path);
            files[i] = file;
        }

        BatchDownloadRequest bdRequest = new BatchDownloadRequest(fileName);
        bdRequest.setFiles(files);
        ;

        OutputStream out = null;
        try {
            File file = File.createTempFile("test", ".zip");
            out = new FileOutputStream(file);
            fileService.batchDownload(bdRequest, out, userAgent);
            TempFileCache cache = CacheFactory.getCommonCacheFactory().getTempFileCache();
            return cache.saveAsUrl(file.getName(), new FileInputStream(file), 2 * 60);

        } catch (FileNotFoundException e) {
            e.printStackTrace();
            return null;
        } catch (IOException e) {
            e.printStackTrace();
            return null;
        }
    }
}
