package nckd.yjk.yj.plugin.docLibrary.utils;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import kd.bos.url.UrlService;
import org.apache.http.HttpEntity;
import org.apache.http.HttpStatus;
import org.apache.http.client.config.RequestConfig;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;

import com.alibaba.fastjson.JSONObject;

import kd.bos.dataentity.utils.StringUtils;

/**
 * 第三方系统远程上传单据&附件到苍穹系统
 * 
 * @author Administrator
 *
 */
public class RemoteOperationWithAttachment {
	
	// 苍穹系统访问地址,需修改
	private static final String REMOTEHOST = UrlService.getDomainContextUrl();

//    private final static String  URL_COSMICHOST="http://111.75.220.136:8022/ierp";

	
	// 苍穹系统中,对应单据的标识,需修改
	private static final String FORMID = "nckd_requisitionlist";
	
	// 苍穹系统中,对应单据所属应用的标识,需修改
	private static final String APPID = "nckd_requirements";
	
	/***************************************** 临时变量 *****************************************/
	// 苍穹系统中, 该单据的所有附件面板上的附件信息(key:附件面板标识符;value:附件信息集合)
	private Map<String, List<Map<String, Object>>> collection = null;
	// 苍穹系统中, 该单据的所有附件面板标识
	private List<String> attachKeys = null;
	
	/**
	 * 测试入口(上传、下载请分开测试)
	 * 
	 * @param args
	 */
	public static void main(String[] args) {
		RemoteOperationWithAttachment remoteOperation = new RemoteOperationWithAttachment();
		// 获取连接信息,需修改(在方法体内)
		String appToken = AppLoginService.getService().getAppToken(REMOTEHOST);
		String accessToken = UserLoginService.getService().getAccessToken(REMOTEHOST, appToken);
		// 远程上传单据&附件
//		try {
//			remoteOperation.remoteSaveWithAttachments (accessToken);
//		} catch (Exception e) {
//			e.printStackTrace();
//		}
		
		// 查询苍穹系统中指定单据上的所有附件信息
		try {
			remoteOperation.remoteGetAttachmentsInfo(accessToken);
		} catch (Exception e) {
			e.printStackTrace();
		}
		// 远程下载附件
		try {
			remoteOperation.remoteDownloadAttachment(accessToken);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	/**
	 * 远程上传单据&附件到苍穹系统
	 * 参考资料:https://www.cnblogs.com/zwqh/p/9635176.html
	 *        https://blog.csdn.net/zzq900503/article/details/72920914/
	 * 
	 * @throws Exception
	 */
	private void remoteSaveWithAttachments(String accessToken) throws Exception {
		// 第三方系统中待上传到苍穹系统的文件,需修改
		File file = new File("E:\\test.txt");
		// 上传可能需要传的参数
        Map<String, Object> param = new HashMap<String, Object>();	     
        String responseStr = null;
        JSONObject responseJson = null;
		String url = REMOTEHOST + "/attachment/uploadFile.do";
		// 上传文件		
		responseStr = FileUploadService.getService().postFile(url, param, file, accessToken);
		// 封装第三方系统中待上传到苍穹系统的单据数据
		Map<String, Object> formData = new HashMap<String, Object>();
		// 单据标识符,需修改(苍穹系统中需要该参数,如第三方系统没有该参数,可自行新建,格式:开发商标识符+单据名称,英文或者数字,附:开发商标识符可在苍穹系统中查询到)
		formData.put("formId", FORMID);
		formData.put("appId", APPID);
		formData.put("fileName", file.getName());
		formData.put("fileSize", file.length());
		formData.put("description", "");
		formData.put("bizType", "upload");
		// 单据数据,按实际业务自行修改
		formData.put("billno", "test20190819");
		formData.put("billstatus", "B");
		formData.put("desc", "测试");
		formData.put("qtyfield1", "12");
		responseStr = BizOperateService.getService().BizSave(REMOTEHOST, accessToken, formData, responseStr, null);
		responseJson = JSONObject.parseObject(responseStr);
		Boolean success = Boolean.valueOf(responseJson.getString("success"));
		if (success) {
			System.out.println("上传成功！");
		} else {
			String message = responseJson.getJSONObject("data").getString("message");
			throw new Exception(message);
		}
	}
	
	/**
	 * 远程查询附件信息
	 * @param accessToken
	 * @throws Exception
	 */
	private void remoteGetAttachmentsInfo(String accessToken) throws Exception {
		String responseStr = null;
		Map<String, Object> params = new HashMap<String, Object>();
		params.put("bizType", "getAttachments");
		params.put("formId", FORMID);
		// 待查询单据的主键ID,需修改
		params.put("pkId", "697030778130792448");
		// 可不传,查询默认附件面板的所有附件信息
		// 如存在多个附件面板,或附件面板标识与默认附件面板标识("attachmentpanel")不一致,或查询指定附件面板的所有附件信息,需修改
		params.put("attachKeys", attachKeys);
		responseStr = BizOperateService.getService().bizGetAttachmentsInfo(REMOTEHOST, accessToken, params);
		JSONObject responseJson = StringUtils.isEmpty(responseStr) ? new JSONObject() : JSONObject.parseObject(responseStr);
		Boolean success = responseJson == null ? false : Boolean.valueOf(responseJson.getString("success"));
		if (success) {
			attachKeys = (List<String>) responseJson.getJSONObject("data").get("attachKeys");
			collection = (Map<String, List<Map<String, Object>>>) responseJson.getJSONObject("data").get("collection");
		} else {
			String message = responseJson.getJSONObject("data").getString("message");
			message = StringUtils.isEmpty(message) ? "远程查询附件信息失败！" : message;
			throw new Exception(message);
		}
		System.out.println(collection);
	}
	
	/**
	 * 远程下载附件
	 * 参考资料:https://blog.csdn.net/u014267900/article/details/80712357
	 *        https://www.cnblogs.com/lucas1024/p/9533220.html
	 *        https://www.cnblogs.com/Donnnnnn/p/7902718.html
	 * 
	 * @param accessToken
	 * @throws Exception
	 */
	private void remoteDownloadAttachment(String accessToken) throws Exception {
		// 下载指定附件,需修改
		String attachKey = attachKeys.get(0);
		List<Map<String, Object>> attachments = collection.get(attachKey);
		Map<String, Object> attachment = attachments.get(0);
		String url = attachment.get("url").toString();
		InputStream is = null;
		// 创建默认http客户端
		CloseableHttpClient httpClient = HttpClients.createDefault();
		// 采用默认请求配置
		RequestConfig requestConfig= RequestConfig.DEFAULT;
		// 通过get方法下载文件流
		HttpGet request = new HttpGet(url);
		// 设置请头求配置
		request.setConfig(requestConfig);
		try {
			// 执行请求，接收返回信息
			CloseableHttpResponse httpResponse = httpClient.execute(request);
			// 获取执行状态
			int statusCode = httpResponse.getStatusLine().getStatusCode();
			if (statusCode != HttpStatus.SC_OK && statusCode != HttpStatus.SC_CREATED) {
				request.abort();
			} else {
				HttpEntity entity = httpResponse.getEntity();
				if (null != entity) {
					// 获取返回内容
					is = entity.getContent();
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
			request.abort();
		}
		// 本地存放位置
		String path = "E:\\测试下载远程文件\\demo.txt";
		File file = new File(path);
		if (!file.getParentFile().exists()) {
			file.getParentFile().mkdirs();
		}
		if (!file.exists()) {
			try {
				file.createNewFile();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		FileOutputStream fos = null;
		try {
			fos = new FileOutputStream(file);
			int bytes = 0;
			byte[] buffer = new byte[1024];
			while ((bytes = is.read(buffer)) != -1) {
			    fos.write(buffer, 0, bytes);
			}
			System.out.println("文件下载成功！");
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			close(is);
			close(fos);
		}
	}
	
	/**
	 * 关闭输入流
	 * @param is
	 */
	public static void close(InputStream is) {
		if (is != null) {
			try {
				is.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}
	
	/**
	 * 关闭输出流
	 * @param fos
	 */
	public static void close(FileOutputStream fos) {
		if (fos != null) {
			try {
				fos.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}
	
}
