package sys.sc.formplugin;

import kd.bos.context.RequestContext;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.LocaleString;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.events.BeforeDoOperationEventArgs;
import kd.bos.form.operate.AbstractOperate;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.user.UserServiceHelper;

import java.util.EventObject;

/**
 * @author cjz
 * @date 2024/10/24 15:09
 * @description:员工收款信息表(人力薪酬)
 */
public class PayInformationPlugin extends AbstractFormPlugin {

    private static String nckd_payeenum="nckd_payeenum";//收款人工号标识
    private static String nckd_adminnum="nckd_adminnum";//管理员工号标识
    private static String bos_user="bos_user";//人员表标识


    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
        long userID = UserServiceHelper.getCurrentUserId();
        DynamicObject user=BusinessDataServiceHelper
                .loadSingle("bos_user","id,name",new QFilter[]{new QFilter("id",QCP.equals,userID)});
        //设置管理员工号为当前用户
        this.getModel().setValue("nckd_adminnum",user);
        String name= user.getLocaleString("name").getLocaleValue();
        //管理员姓名
        this.getModel().setValue("nckd_adminname",name);

    }


    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.beforePropertyChanged(e);
        String name = e.getProperty().getName();//获取字段标识
        //获取当前单据
        DynamicObject dynamicObject=this.getModel().getDataEntity(true);
        //选择收款人工号后自动带出收款人姓名
        if (nckd_payeenum.equals(name)) {
            ChangeData[] changeSet = e.getChangeSet();//获取值
            ChangeData changeData = changeSet[0];
            DynamicObject payObj= (DynamicObject) changeData.getNewValue();
            QFilter filter=new QFilter("number", QCP.equals,payObj.get("number"));
            DynamicObject payeeuser= BusinessDataServiceHelper.loadSingle(bos_user,QCP.equals,new QFilter[]{filter});
            String payname= payeeuser.getLocaleString("name").getLocaleValue();
            //设置收款人姓名
            this.getModel().setValue("nckd_payeename",payname);
        }
    }



}
